/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         aalogparse_parse
#define yylex           aalogparse_lex
#define yyerror         aalogparse_error
#define yydebug         aalogparse_debug
#define yynerrs         aalogparse_nerrs


/* Copy the first part of user declarations.  */
#line 19 "grammar.y" /* yacc.c:339  */


#define YYDEBUG 0
#include <string.h>
#include "aalogparse.h"
#include "parser.h"
#include "grammar.h"
#include "scanner.h"

aa_log_record *ret_record;

/* Since we're a library, on any errors we don't want to print out any
 * error messages. We should probably add a debug interface that does
 * emit messages when asked for. */
void aalogparse_error(void *scanner, char const *s)
{
        //printf("ERROR: %s\n", s);
	ret_record->event = AA_RECORD_INVALID;
}

struct aa_type_table {
	unsigned int audit_type;
	aa_record_event_type event;
};

static struct aa_type_table aa_type_table[] = {
	{AUDIT_APPARMOR_AUDIT,   AA_RECORD_AUDIT},
	{AUDIT_APPARMOR_ALLOWED, AA_RECORD_ALLOWED},
	{AUDIT_APPARMOR_DENIED,  AA_RECORD_DENIED},
	{AUDIT_APPARMOR_HINT,    AA_RECORD_HINT},
	{AUDIT_APPARMOR_STATUS,  AA_RECORD_STATUS},
	{AUDIT_APPARMOR_ERROR,   AA_RECORD_ERROR},
	{0,                      AA_RECORD_INVALID},
};

aa_record_event_type lookup_aa_event(unsigned int type)
{
	int i;

	for (i = 0; aa_type_table[i].audit_type != 0; i++)
		if (type == aa_type_table[i].audit_type)
			break;

	return aa_type_table[i].event;
}



#line 121 "grammar.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_AALOGPARSE_GRAMMAR_H_INCLUDED
# define YY_AALOGPARSE_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int aalogparse_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_DIGITS = 258,
    TOK_TYPE_UNKNOWN = 259,
    TOK_QUOTED_STRING = 260,
    TOK_PATH = 261,
    TOK_ID = 262,
    TOK_NULL_COMPLAIN = 263,
    TOK_MODE = 264,
    TOK_DMESG_STAMP = 265,
    TOK_SINGLE_QUOTED_STRING = 266,
    TOK_AUDIT_DIGITS = 267,
    TOK_DATE_MONTH = 268,
    TOK_DATE_TIME = 269,
    TOK_HEXSTRING = 270,
    TOK_TYPE_OTHER = 271,
    TOK_MSG_REST = 272,
    TOK_EQUALS = 273,
    TOK_COLON = 274,
    TOK_OPEN_PAREN = 275,
    TOK_CLOSE_PAREN = 276,
    TOK_PERIOD = 277,
    TOK_TYPE_REJECT = 278,
    TOK_TYPE_AUDIT = 279,
    TOK_TYPE_COMPLAIN = 280,
    TOK_TYPE_HINT = 281,
    TOK_TYPE_STATUS = 282,
    TOK_TYPE_ERROR = 283,
    TOK_OLD_TYPE_APPARMOR = 284,
    TOK_OLD_APPARMOR_REJECT = 285,
    TOK_OLD_APPARMOR_PERMIT = 286,
    TOK_OLD_APPARMOR_AUDIT = 287,
    TOK_OLD_APPARMOR_LOGPROF_HINT = 288,
    TOK_OLD_UNKNOWN_HAT = 289,
    TOK_OLD_ACTIVE = 290,
    TOK_OLD_UNKNOWN_PROFILE = 291,
    TOK_OLD_MISSING_PROFILE = 292,
    TOK_OLD_CHANGING_PROFILE = 293,
    TOK_OLD_ACCESS = 294,
    TOK_OLD_TO = 295,
    TOK_OLD_FROM = 296,
    TOK_OLD_PIPE = 297,
    TOK_OLD_EXTENDED = 298,
    TOK_OLD_ATTRIBUTE = 299,
    TOK_OLD_ON = 300,
    TOK_OLD_MKDIR = 301,
    TOK_OLD_RMDIR = 302,
    TOK_OLD_XATTR = 303,
    TOK_OLD_CHANGE = 304,
    TOK_OLD_CAPABILITY = 305,
    TOK_OLD_SYSCALL = 306,
    TOK_OLD_LINK = 307,
    TOK_OLD_FORK = 308,
    TOK_OLD_CHILD = 309,
    TOK_KEY_TYPE = 310,
    TOK_KEY_MSG = 311,
    TOK_KEY_OPERATION = 312,
    TOK_KEY_NAME = 313,
    TOK_KEY_NAME2 = 314,
    TOK_KEY_DENIED_MASK = 315,
    TOK_KEY_REQUESTED_MASK = 316,
    TOK_KEY_ATTRIBUTE = 317,
    TOK_KEY_TASK = 318,
    TOK_KEY_PARENT = 319,
    TOK_KEY_MAGIC_TOKEN = 320,
    TOK_KEY_INFO = 321,
    TOK_KEY_PID = 322,
    TOK_KEY_PROFILE = 323,
    TOK_AUDIT = 324,
    TOK_KEY_IMAGE = 325,
    TOK_KEY_FAMILY = 326,
    TOK_KEY_SOCK_TYPE = 327,
    TOK_KEY_PROTOCOL = 328,
    TOK_KEY_NAMESPACE = 329,
    TOK_KEY_ERROR = 330,
    TOK_KEY_FSUID = 331,
    TOK_SYSLOG_KERNEL = 332
  };
#endif
/* Tokens.  */
#define TOK_DIGITS 258
#define TOK_TYPE_UNKNOWN 259
#define TOK_QUOTED_STRING 260
#define TOK_PATH 261
#define TOK_ID 262
#define TOK_NULL_COMPLAIN 263
#define TOK_MODE 264
#define TOK_DMESG_STAMP 265
#define TOK_SINGLE_QUOTED_STRING 266
#define TOK_AUDIT_DIGITS 267
#define TOK_DATE_MONTH 268
#define TOK_DATE_TIME 269
#define TOK_HEXSTRING 270
#define TOK_TYPE_OTHER 271
#define TOK_MSG_REST 272
#define TOK_EQUALS 273
#define TOK_COLON 274
#define TOK_OPEN_PAREN 275
#define TOK_CLOSE_PAREN 276
#define TOK_PERIOD 277
#define TOK_TYPE_REJECT 278
#define TOK_TYPE_AUDIT 279
#define TOK_TYPE_COMPLAIN 280
#define TOK_TYPE_HINT 281
#define TOK_TYPE_STATUS 282
#define TOK_TYPE_ERROR 283
#define TOK_OLD_TYPE_APPARMOR 284
#define TOK_OLD_APPARMOR_REJECT 285
#define TOK_OLD_APPARMOR_PERMIT 286
#define TOK_OLD_APPARMOR_AUDIT 287
#define TOK_OLD_APPARMOR_LOGPROF_HINT 288
#define TOK_OLD_UNKNOWN_HAT 289
#define TOK_OLD_ACTIVE 290
#define TOK_OLD_UNKNOWN_PROFILE 291
#define TOK_OLD_MISSING_PROFILE 292
#define TOK_OLD_CHANGING_PROFILE 293
#define TOK_OLD_ACCESS 294
#define TOK_OLD_TO 295
#define TOK_OLD_FROM 296
#define TOK_OLD_PIPE 297
#define TOK_OLD_EXTENDED 298
#define TOK_OLD_ATTRIBUTE 299
#define TOK_OLD_ON 300
#define TOK_OLD_MKDIR 301
#define TOK_OLD_RMDIR 302
#define TOK_OLD_XATTR 303
#define TOK_OLD_CHANGE 304
#define TOK_OLD_CAPABILITY 305
#define TOK_OLD_SYSCALL 306
#define TOK_OLD_LINK 307
#define TOK_OLD_FORK 308
#define TOK_OLD_CHILD 309
#define TOK_KEY_TYPE 310
#define TOK_KEY_MSG 311
#define TOK_KEY_OPERATION 312
#define TOK_KEY_NAME 313
#define TOK_KEY_NAME2 314
#define TOK_KEY_DENIED_MASK 315
#define TOK_KEY_REQUESTED_MASK 316
#define TOK_KEY_ATTRIBUTE 317
#define TOK_KEY_TASK 318
#define TOK_KEY_PARENT 319
#define TOK_KEY_MAGIC_TOKEN 320
#define TOK_KEY_INFO 321
#define TOK_KEY_PID 322
#define TOK_KEY_PROFILE 323
#define TOK_AUDIT 324
#define TOK_KEY_IMAGE 325
#define TOK_KEY_FAMILY 326
#define TOK_KEY_SOCK_TYPE 327
#define TOK_KEY_PROTOCOL 328
#define TOK_KEY_NAMESPACE 329
#define TOK_KEY_ERROR 330
#define TOK_KEY_FSUID 331
#define TOK_SYSLOG_KERNEL 332

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 74 "grammar.y" /* yacc.c:355  */

	char	*t_str;
	long	t_long;

#line 320 "grammar.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int aalogparse_parse (void *scanner);

#endif /* !YY_AALOGPARSE_GRAMMAR_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 336 "grammar.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  13
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   279

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  31
/* YYNRULES -- Number of rules.  */
#define YYNRULES  86
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  251

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   332

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   151,   151,   152,   153,   156,   158,   159,   160,   163,
     164,   168,   169,   170,   171,   172,   173,   174,   177,   186,
     188,   190,   192,   194,   200,   200,   205,   206,   210,   211,
     212,   216,   222,   227,   234,   242,   248,   254,   264,   265,
     269,   278,   285,   289,   293,   299,   307,   308,   313,   320,
     327,   338,   346,   348,   356,   357,   358,   361,   364,   374,
     377,   378,   381,   383,   385,   387,   389,   391,   393,   395,
     397,   399,   401,   403,   404,   406,   408,   410,   412,   414,
     416,   420,   423,   426,   427,   430,   431
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_DIGITS", "TOK_TYPE_UNKNOWN",
  "TOK_QUOTED_STRING", "TOK_PATH", "TOK_ID", "TOK_NULL_COMPLAIN",
  "TOK_MODE", "TOK_DMESG_STAMP", "TOK_SINGLE_QUOTED_STRING",
  "TOK_AUDIT_DIGITS", "TOK_DATE_MONTH", "TOK_DATE_TIME", "TOK_HEXSTRING",
  "TOK_TYPE_OTHER", "TOK_MSG_REST", "TOK_EQUALS", "TOK_COLON",
  "TOK_OPEN_PAREN", "TOK_CLOSE_PAREN", "TOK_PERIOD", "TOK_TYPE_REJECT",
  "TOK_TYPE_AUDIT", "TOK_TYPE_COMPLAIN", "TOK_TYPE_HINT",
  "TOK_TYPE_STATUS", "TOK_TYPE_ERROR", "TOK_OLD_TYPE_APPARMOR",
  "TOK_OLD_APPARMOR_REJECT", "TOK_OLD_APPARMOR_PERMIT",
  "TOK_OLD_APPARMOR_AUDIT", "TOK_OLD_APPARMOR_LOGPROF_HINT",
  "TOK_OLD_UNKNOWN_HAT", "TOK_OLD_ACTIVE", "TOK_OLD_UNKNOWN_PROFILE",
  "TOK_OLD_MISSING_PROFILE", "TOK_OLD_CHANGING_PROFILE", "TOK_OLD_ACCESS",
  "TOK_OLD_TO", "TOK_OLD_FROM", "TOK_OLD_PIPE", "TOK_OLD_EXTENDED",
  "TOK_OLD_ATTRIBUTE", "TOK_OLD_ON", "TOK_OLD_MKDIR", "TOK_OLD_RMDIR",
  "TOK_OLD_XATTR", "TOK_OLD_CHANGE", "TOK_OLD_CAPABILITY",
  "TOK_OLD_SYSCALL", "TOK_OLD_LINK", "TOK_OLD_FORK", "TOK_OLD_CHILD",
  "TOK_KEY_TYPE", "TOK_KEY_MSG", "TOK_KEY_OPERATION", "TOK_KEY_NAME",
  "TOK_KEY_NAME2", "TOK_KEY_DENIED_MASK", "TOK_KEY_REQUESTED_MASK",
  "TOK_KEY_ATTRIBUTE", "TOK_KEY_TASK", "TOK_KEY_PARENT",
  "TOK_KEY_MAGIC_TOKEN", "TOK_KEY_INFO", "TOK_KEY_PID", "TOK_KEY_PROFILE",
  "TOK_AUDIT", "TOK_KEY_IMAGE", "TOK_KEY_FAMILY", "TOK_KEY_SOCK_TYPE",
  "TOK_KEY_PROTOCOL", "TOK_KEY_NAMESPACE", "TOK_KEY_ERROR",
  "TOK_KEY_FSUID", "TOK_SYSLOG_KERNEL", "$accept", "log_message",
  "audit_type", "type_syntax", "old_syntax", "new_syntax", "other_audit",
  "syslog_type", "audit_dispatch", "$@1", "old_msg",
  "old_permit_reject_type", "old_permit_reject_syntax", "dir_action",
  "old_process_state", "old_profile_names",
  "old_permit_reject_path_pipe_extended", "old_logprof_syntax",
  "old_logprof_syntax2", "old_logprof_fork_syntax",
  "old_logprof_fork_addition", "old_profile", "audit_msg", "audit_id",
  "syslog_date", "key_list", "key", "key_pid", "key_type", "safe_string",
  "protocol", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332
};
# endif

#define YYPACT_NINF -161

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-161)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       0,     5,    -4,    14,    40,  -161,  -161,  -161,    37,    35,
      30,   102,   -16,  -161,  -161,  -161,  -161,    85,  -161,     2,
     -20,  -161,     7,     7,     7,     7,     7,     7,     7,     7,
       7,  -161,  -161,  -161,  -161,    45,  -161,    68,     9,    11,
      18,    18,  -161,    18,  -161,     7,    59,    69,  -161,  -161,
      92,    76,    88,  -161,    79,    -3,    29,   116,    95,    95,
      95,    95,    95,    95,    37,   122,  -161,   117,   121,   133,
    -161,    83,    97,    95,    67,   -13,   127,   132,   167,   169,
     -46,   158,    29,   -16,   159,   160,   161,   162,   163,   164,
     165,   166,   168,   170,   171,   172,   173,   174,   175,   176,
     177,   178,  -161,    95,  -161,  -161,  -161,    95,    95,    95,
      95,    95,    95,  -161,   179,   180,   190,   182,   181,   184,
      95,    16,   136,   183,   189,   193,   199,   200,   186,   188,
      95,   -16,   206,  -161,    95,    95,   207,   208,    21,    21,
     209,   210,   211,   214,   215,   216,   217,    21,   218,   219,
      25,    21,   222,   223,  -161,   220,  -161,  -161,  -161,   224,
     105,  -161,  -161,  -161,   204,   192,   201,   213,   191,   185,
     204,    95,    95,  -161,    95,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,   221,   152,  -161,
    -161,  -161,   194,   225,   226,   204,   204,   204,   229,   196,
     227,    95,   230,   212,  -161,   228,   231,  -161,   232,   233,
     234,   236,   235,  -161,   237,   105,   105,   238,  -161,  -161,
    -161,   204,   240,   242,   202,  -161,   195,   241,   204,  -161,
     239,   105,  -161,  -161,   243,   105,   244,  -161,  -161,   105,
    -161
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     2,     3,     4,     0,     0,
       0,     0,     0,     1,    28,    29,    30,     0,    24,     0,
       0,    59,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     6,     7,     8,     0,    57,     0,     0,     0,
       0,     0,    27,     0,    46,     0,     0,     0,    38,    39,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     0,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,    17,    60,    73,    18,    11,    12,    13,
      14,    15,    16,     9,     0,     0,     0,     0,     0,     0,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,     0,    48,    49,    81,     0,
       0,    42,    43,    44,     0,     0,     0,     0,     0,     0,
       0,    22,     0,    82,    21,    78,    62,    83,    84,    63,
      65,    66,    67,    68,    69,    70,    71,    72,    74,    75,
      76,    86,    85,    77,    64,    79,    80,     0,    52,    54,
      55,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    23,     0,     0,    51,     0,     0,    31,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,    35,    36,
      33,     0,     0,     0,     0,    45,     0,     0,     0,    58,
       0,     0,    40,    37,     0,     0,     0,    34,    53,     0,
      41
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
     -31,  -161,  -161,  -161,  -160,  -161,  -161,  -161,  -161,  -161,
    -161,  -109,   119,   -49,  -161,   -58,   -91,    33,   148,  -112,
    -161
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     4,     5,    31,    32,    33,    34,     6,     7,    45,
      18,    19,    53,    54,   204,   242,   123,    42,    43,    44,
     214,   202,     8,    36,     9,   103,   104,   105,    83,   179,
     193
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
     107,   108,   109,   110,   111,   112,    82,    80,    10,    81,
     210,    46,   154,     1,    11,   120,   154,   154,   154,   154,
     154,   154,   161,    35,   134,   102,   177,   180,   191,   154,
     192,   130,    12,   113,   135,   188,   178,   124,   125,   194,
      13,    47,    20,   154,    21,   218,   219,   220,    48,    49,
      50,   133,    81,    35,    51,     2,     3,    55,   162,    14,
      15,    16,    17,     3,    52,    65,    35,    14,    15,    16,
      17,   237,   171,    70,    71,    66,    72,   174,   244,    67,
     154,    68,   172,   154,    84,    69,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    69,    95,    74,    76,
      96,    97,    98,    99,   100,   101,    22,   121,    78,    75,
     122,   199,   200,   201,   211,    77,   234,   235,    23,    37,
     154,    38,    39,    40,    79,    24,    25,    26,    27,    28,
      29,    30,   246,   106,   114,   115,   248,   118,    41,   116,
     250,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      84,   117,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    69,    95,    73,   119,    96,    97,    98,    99,
     100,   101,   126,   127,   128,   129,   132,   136,   137,   138,
     139,   140,   141,   142,   143,   158,   144,   156,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   157,   163,   159,
     165,   155,   160,   164,   166,   167,   168,   169,   170,   173,
     175,   203,   205,   176,   181,   182,   183,   184,   185,   186,
     213,   206,   187,   189,   190,   195,   196,   198,   131,   215,
     225,   208,   197,   207,   209,   221,   222,   240,   227,     0,
     212,   232,   224,     0,     0,   216,   226,   217,   223,     0,
       0,     0,     0,   228,   229,   230,   231,   245,   233,   236,
     238,   239,   243,   241,   247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   249
};

static const yytype_int16 yycheck[] =
{
      58,    59,    60,    61,    62,    63,    55,    10,     3,    55,
     170,     9,   103,    13,    18,    73,   107,   108,   109,   110,
     111,   112,     6,    69,    82,    56,     5,   139,     3,   120,
       5,    80,    18,    64,    83,   147,    15,    50,    51,   151,
       0,    39,     7,   134,    14,   205,   206,   207,    46,    47,
      48,    82,    55,    69,    52,    55,    56,    77,    42,    30,
      31,    32,    33,    56,    62,    20,    69,    30,    31,    32,
      33,   231,   130,    40,    41,     7,    43,   135,   238,    70,
     171,    70,   131,   174,    55,    67,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    39,     7,
      71,    72,    73,    74,    75,    76,     4,    40,    20,    40,
      43,     6,     7,     8,   172,    39,   225,   226,    16,    34,
     211,    36,    37,    38,    45,    23,    24,    25,    26,    27,
      28,    29,   241,    17,    12,    18,   245,    54,    53,    18,
     249,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      55,    18,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    45,    68,    71,    72,    73,    74,
      75,    76,    45,    41,     7,     6,    18,    18,    18,    18,
      18,    18,    18,    18,    18,     3,    18,     7,    18,    18,
      18,    18,    18,    18,    18,    18,    18,     7,    62,    18,
      11,    22,    18,    20,    11,     6,     6,    21,    20,     3,
       3,     7,    20,     5,     5,     5,     5,     3,     3,     3,
      68,    20,     5,     5,     5,     3,     3,     3,    80,    35,
      18,    40,    12,    20,    49,     6,    40,    35,     7,    -1,
      19,     6,    12,    -1,    -1,    20,    18,    21,    21,    -1,
      -1,    -1,    -1,    21,    21,    21,    20,    18,    21,    21,
      20,    19,    21,    68,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,    55,    56,    79,    80,    85,    86,   100,   102,
       3,    18,    18,     0,    30,    31,    32,    33,    88,    89,
       7,    14,     4,    16,    23,    24,    25,    26,    27,    28,
      29,    81,    82,    83,    84,    69,   101,    34,    36,    37,
      38,    53,    95,    96,    97,    87,     9,    39,    46,    47,
      48,    52,    62,    90,    91,    77,   100,   100,   100,   100,
     100,   100,   100,   100,   100,    20,     7,    70,    70,    67,
     105,   105,   105,   100,    39,    40,     7,    39,    20,    45,
      10,    55,   101,   106,    55,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    68,    71,    72,    73,    74,
      75,    76,    88,   103,   104,   105,    17,   103,   103,   103,
     103,   103,   103,    88,    12,    18,    18,    18,    54,    68,
     103,    40,    43,    94,    50,    51,    45,    41,     7,     6,
     101,   106,    18,    88,   103,   101,    18,    18,    18,    18,
      18,    18,    18,    18,    18,    18,    18,    18,    18,    18,
      18,    18,    18,    18,   104,    22,     7,     7,     3,    18,
      18,     6,    42,    62,    20,    11,    11,     6,     6,    21,
      20,   103,   101,     3,   103,     3,     5,     5,    15,   107,
     107,     5,     5,     5,     3,     3,     3,     5,   107,     5,
       5,     3,     5,   108,   107,     3,     3,    12,     3,     6,
       7,     8,    99,     7,    92,    20,    20,    20,    40,    49,
      92,   103,    19,    68,    98,    35,    20,    21,    92,    92,
      92,     6,    40,    21,    12,    18,    18,     7,    21,    21,
      21,    20,     6,    21,    99,    99,    21,    92,    20,    19,
      35,    68,    93,    21,    92,    18,    99,    21,    99,    35,
      99
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    78,    79,    79,    79,    80,    81,    81,    81,    82,
      82,    83,    83,    83,    83,    83,    83,    83,    84,    85,
      85,    85,    85,    85,    87,    86,    88,    88,    89,    89,
      89,    90,    90,    90,    90,    90,    90,    90,    91,    91,
      92,    93,    94,    94,    94,    95,    95,    95,    96,    96,
      96,    97,    98,    98,    99,    99,    99,   100,   101,   102,
     103,   103,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   105,   106,   107,   107,   108,   108
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     3,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       5,     6,     6,     7,     0,     5,     2,     2,     1,     1,
       1,     6,     6,     7,    10,     7,     7,     9,     1,     1,
       5,     4,     2,     2,     2,     8,     1,     2,     4,     4,
       2,     6,     0,     6,     1,     1,     1,     3,     9,     3,
       1,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, void *scanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
{
  YYUSE (yyvaluep);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 158 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
#line 1611 "grammar.c" /* yacc.c:1646  */
    break;

  case 7:
#line 159 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1617 "grammar.c" /* yacc.c:1646  */
    break;

  case 11:
#line 168 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 1623 "grammar.c" /* yacc.c:1646  */
    break;

  case 12:
#line 169 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 1629 "grammar.c" /* yacc.c:1646  */
    break;

  case 13:
#line 170 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 1635 "grammar.c" /* yacc.c:1646  */
    break;

  case 14:
#line 171 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 1641 "grammar.c" /* yacc.c:1646  */
    break;

  case 15:
#line 172 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 1647 "grammar.c" /* yacc.c:1646  */
    break;

  case 16:
#line 173 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 1653 "grammar.c" /* yacc.c:1646  */
    break;

  case 17:
#line 174 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[-2].t_long)); }
#line 1659 "grammar.c" /* yacc.c:1646  */
    break;

  case 18:
#line 178 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = (yyvsp[-2].t_str);
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 1669 "grammar.c" /* yacc.c:1646  */
    break;

  case 19:
#line 187 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
#line 1675 "grammar.c" /* yacc.c:1646  */
    break;

  case 20:
#line 189 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1681 "grammar.c" /* yacc.c:1646  */
    break;

  case 21:
#line 191 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1687 "grammar.c" /* yacc.c:1646  */
    break;

  case 22:
#line 193 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1693 "grammar.c" /* yacc.c:1646  */
    break;

  case 23:
#line 195 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1699 "grammar.c" /* yacc.c:1646  */
    break;

  case 24:
#line 200 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V1; }
#line 1705 "grammar.c" /* yacc.c:1646  */
    break;

  case 25:
#line 201 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1711 "grammar.c" /* yacc.c:1646  */
    break;

  case 27:
#line 206 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 1717 "grammar.c" /* yacc.c:1646  */
    break;

  case 28:
#line 210 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 1723 "grammar.c" /* yacc.c:1646  */
    break;

  case 29:
#line 211 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 1729 "grammar.c" /* yacc.c:1646  */
    break;

  case 30:
#line 212 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 1735 "grammar.c" /* yacc.c:1646  */
    break;

  case 31:
#line 218 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->requested_mask = (yyvsp[-5].t_str);
		ret_record->operation = strdup("access");
	}
#line 1744 "grammar.c" /* yacc.c:1646  */
    break;

  case 32:
#line 224 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->name = (yyvsp[-3].t_str);
	}
#line 1752 "grammar.c" /* yacc.c:1646  */
    break;

  case 33:
#line 229 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = strdup("xattr");
		ret_record->attribute = (yyvsp[-5].t_str);
		ret_record->name = (yyvsp[-3].t_str);
	}
#line 1762 "grammar.c" /* yacc.c:1646  */
    break;

  case 34:
#line 237 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = strdup("setattr");
		ret_record->attribute = (yyvsp[-7].t_str);
		ret_record->name = (yyvsp[-3].t_str);
	}
#line 1772 "grammar.c" /* yacc.c:1646  */
    break;

  case 35:
#line 244 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = strdup("capability");
		ret_record->name = (yyvsp[-3].t_str);
	}
#line 1781 "grammar.c" /* yacc.c:1646  */
    break;

  case 36:
#line 250 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = strdup("syscall");
		ret_record->name = (yyvsp[-3].t_str);
	}
#line 1790 "grammar.c" /* yacc.c:1646  */
    break;

  case 37:
#line 256 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->requested_mask = strdup("l");
		ret_record->name = (yyvsp[-5].t_str);
		ret_record->name2 = (yyvsp[-3].t_str);
	}
#line 1800 "grammar.c" /* yacc.c:1646  */
    break;

  case 38:
#line 264 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = strdup("mkdir"); }
#line 1806 "grammar.c" /* yacc.c:1646  */
    break;

  case 39:
#line 265 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = strdup("rmdir"); }
#line 1812 "grammar.c" /* yacc.c:1646  */
    break;

  case 40:
#line 270 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->info = (yyvsp[-4].t_str);
		ret_record->pid = atol((yyvsp[-2].t_str));
		free((yyvsp[-2].t_str));
	}
#line 1822 "grammar.c" /* yacc.c:1646  */
    break;

  case 41:
#line 279 "grammar.y" /* yacc.c:1646  */
    {	ret_record->profile = (yyvsp[-2].t_str);
		ret_record->active_hat = (yyvsp[0].t_str);
	}
#line 1830 "grammar.c" /* yacc.c:1646  */
    break;

  case 42:
#line 286 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->name = (yyvsp[0].t_str);
		}
#line 1838 "grammar.c" /* yacc.c:1646  */
    break;

  case 43:
#line 290 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->info = strdup("pipe");
		}
#line 1846 "grammar.c" /* yacc.c:1646  */
    break;

  case 44:
#line 294 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->info = strdup("extended attribute");
		}
#line 1854 "grammar.c" /* yacc.c:1646  */
    break;

  case 45:
#line 301 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->profile = strdup((yyvsp[-3].t_str));
			free((yyvsp[-3].t_str));
			ret_record->active_hat = strdup((yyvsp[0].t_str));
			free((yyvsp[0].t_str));
		}
#line 1865 "grammar.c" /* yacc.c:1646  */
    break;

  case 47:
#line 309 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = strdup("null-complain-profile"); }
#line 1871 "grammar.c" /* yacc.c:1646  */
    break;

  case 48:
#line 314 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->operation = strdup("profile_set");
			ret_record->info = strdup("unknown profile");
			ret_record->name = strdup((yyvsp[0].t_str));
			free((yyvsp[0].t_str));
		}
#line 1882 "grammar.c" /* yacc.c:1646  */
    break;

  case 49:
#line 321 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->operation = strdup("exec");
			ret_record->info = strdup("mandatory profile missing");
			ret_record->name = strdup((yyvsp[0].t_str));
			free((yyvsp[0].t_str));
		}
#line 1893 "grammar.c" /* yacc.c:1646  */
    break;

  case 50:
#line 328 "grammar.y" /* yacc.c:1646  */
    {
			ret_record->operation = strdup("change_hat");
			ret_record->name = strdup((yyvsp[0].t_str));
			free((yyvsp[0].t_str));
			ret_record->info = strdup("unknown_hat");
		}
#line 1904 "grammar.c" /* yacc.c:1646  */
    break;

  case 51:
#line 340 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = strdup("clone");
		ret_record->task = (yyvsp[-1].t_long);
	}
#line 1913 "grammar.c" /* yacc.c:1646  */
    break;

  case 53:
#line 349 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->profile = (yyvsp[-3].t_str);
		ret_record->active_hat = (yyvsp[0].t_str);
	}
#line 1922 "grammar.c" /* yacc.c:1646  */
    break;

  case 54:
#line 356 "grammar.y" /* yacc.c:1646  */
    { (yyval.t_str) = (yyvsp[0].t_str); }
#line 1928 "grammar.c" /* yacc.c:1646  */
    break;

  case 55:
#line 357 "grammar.y" /* yacc.c:1646  */
    { (yyval.t_str) = (yyvsp[0].t_str); }
#line 1934 "grammar.c" /* yacc.c:1646  */
    break;

  case 56:
#line 358 "grammar.y" /* yacc.c:1646  */
    { (yyval.t_str) = strdup("null-complain-profile"); }
#line 1940 "grammar.c" /* yacc.c:1646  */
    break;

  case 58:
#line 365 "grammar.y" /* yacc.c:1646  */
    {
		asprintf(&ret_record->audit_id, "%s.%s:%s", (yyvsp[-6].t_str), (yyvsp[-4].t_str), (yyvsp[-2].t_str));
		ret_record->epoch = atol((yyvsp[-6].t_str));
		ret_record->audit_sub_id = atoi((yyvsp[-2].t_str));
		free((yyvsp[-6].t_str));
		free((yyvsp[-4].t_str));
		free((yyvsp[-2].t_str));
	}
#line 1953 "grammar.c" /* yacc.c:1646  */
    break;

  case 59:
#line 374 "grammar.y" /* yacc.c:1646  */
    { /* do nothing? */ }
#line 1959 "grammar.c" /* yacc.c:1646  */
    break;

  case 62:
#line 382 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = (yyvsp[0].t_str);}
#line 1965 "grammar.c" /* yacc.c:1646  */
    break;

  case 63:
#line 384 "grammar.y" /* yacc.c:1646  */
    { ret_record->name = (yyvsp[0].t_str);}
#line 1971 "grammar.c" /* yacc.c:1646  */
    break;

  case 64:
#line 386 "grammar.y" /* yacc.c:1646  */
    { ret_record->namespace = (yyvsp[0].t_str);}
#line 1977 "grammar.c" /* yacc.c:1646  */
    break;

  case 65:
#line 388 "grammar.y" /* yacc.c:1646  */
    { ret_record->name2 = (yyvsp[0].t_str);}
#line 1983 "grammar.c" /* yacc.c:1646  */
    break;

  case 66:
#line 390 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1989 "grammar.c" /* yacc.c:1646  */
    break;

  case 67:
#line 392 "grammar.y" /* yacc.c:1646  */
    { ret_record->requested_mask = (yyvsp[0].t_str);}
#line 1995 "grammar.c" /* yacc.c:1646  */
    break;

  case 68:
#line 394 "grammar.y" /* yacc.c:1646  */
    { ret_record->attribute = (yyvsp[0].t_str);}
#line 2001 "grammar.c" /* yacc.c:1646  */
    break;

  case 69:
#line 396 "grammar.y" /* yacc.c:1646  */
    { ret_record->task = (yyvsp[0].t_long);}
#line 2007 "grammar.c" /* yacc.c:1646  */
    break;

  case 70:
#line 398 "grammar.y" /* yacc.c:1646  */
    { ret_record->parent = (yyvsp[0].t_long);}
#line 2013 "grammar.c" /* yacc.c:1646  */
    break;

  case 71:
#line 400 "grammar.y" /* yacc.c:1646  */
    { ret_record->magic_token = (yyvsp[0].t_long);}
#line 2019 "grammar.c" /* yacc.c:1646  */
    break;

  case 72:
#line 402 "grammar.y" /* yacc.c:1646  */
    { ret_record->info = (yyvsp[0].t_str);}
#line 2025 "grammar.c" /* yacc.c:1646  */
    break;

  case 74:
#line 405 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 2031 "grammar.c" /* yacc.c:1646  */
    break;

  case 75:
#line 407 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_family = (yyvsp[0].t_str);}
#line 2037 "grammar.c" /* yacc.c:1646  */
    break;

  case 76:
#line 409 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_sock_type = (yyvsp[0].t_str);}
#line 2043 "grammar.c" /* yacc.c:1646  */
    break;

  case 77:
#line 411 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_protocol = (yyvsp[0].t_str);}
#line 2049 "grammar.c" /* yacc.c:1646  */
    break;

  case 78:
#line 413 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long));}
#line 2055 "grammar.c" /* yacc.c:1646  */
    break;

  case 79:
#line 415 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 2061 "grammar.c" /* yacc.c:1646  */
    break;

  case 80:
#line 417 "grammar.y" /* yacc.c:1646  */
    { ret_record->fsuid = (yyvsp[0].t_long);}
#line 2067 "grammar.c" /* yacc.c:1646  */
    break;

  case 81:
#line 420 "grammar.y" /* yacc.c:1646  */
    { ret_record->pid = (yyvsp[0].t_long); }
#line 2073 "grammar.c" /* yacc.c:1646  */
    break;

  case 82:
#line 423 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long)); }
#line 2079 "grammar.c" /* yacc.c:1646  */
    break;

  case 86:
#line 432 "grammar.y" /* yacc.c:1646  */
    { /* FIXME: this should probably convert back to a string proto name */
	  (yyval.t_str) = ipproto_to_string((yyvsp[0].t_long));
	}
#line 2087 "grammar.c" /* yacc.c:1646  */
    break;


#line 2091 "grammar.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 436 "grammar.y" /* yacc.c:1906  */


aa_log_record *
_parse_yacc(char *str)
{
	/* yydebug = 1;  */
	YY_BUFFER_STATE lex_buf;
	yyscan_t scanner;
	int parser_return;

	ret_record = NULL;
	ret_record = (aa_log_record *) malloc(sizeof(aa_log_record));

	_init_log_record(ret_record);

	if (ret_record == NULL)
		return NULL;

	aalogparse_lex_init(&scanner);
	lex_buf = aalogparse__scan_string(str, scanner);
	parser_return = aalogparse_parse(scanner);
	aalogparse__delete_buffer(lex_buf, scanner);
	aalogparse_lex_destroy(scanner);
	return ret_record;
}
